Bug 1492084 - Review Request: movit - GPU video filter library
Summary: Review Request: movit - GPU video filter library
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: srakitnican
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-09-15 12:22 UTC by MartinKG
Modified: 2019-10-26 12:34 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-09-24 07:58:13 UTC
Type: ---
samuel.rakitnican: fedora-review+


Attachments (Terms of Use)

Description MartinKG 2017-09-15 12:22:07 UTC
Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/movit.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/movit-1.5.3-1.fc26.src.rpm

Description: %description
Movit is a library for video filters. It uses the GPU present in many
computers to accelerate computation of common filters and
transitions, facilitating real-time HD video editing.

Fedora Account System Username: martinkg

%changelog
* Sat Sep 09 2017 Martin Gansser <martinkg@fedoraproject.org> - 1.5.3-1
- Initial package: movit-1.5.3


rpmlint -i -v movit.spec /home/martin/rpmbuild/SRPMS/movit-1.5.3-1.fc26.src.rpm /home/martin/rpmbuild/RPMS/x86_64/movit-1.5.3-1.fc26.x86_64.rpm /home/martin/rpmbuild/RPMS/x86_64/movit-devel-1.5.3-1.fc26.x86_64.rpm /home/martin/rpmbuild/RPMS/noarch/movit-data-1.5.3-1.fc26.noarch.rpm /home/martin/rpmbuild/RPMS/x86_64/movit-debuginfo-1.5.3-1.fc26.x86_64.rpm
movit.spec: I: checking
movit.spec: I: checking-url https://movit.sesse.net/movit-1.5.3.tar.gz (timeout 10 seconds)
movit.src: I: checking
movit.src: I: checking-url https://movit.sesse.net (timeout 10 seconds)
movit.src: I: checking-url https://movit.sesse.net/movit-1.5.3.tar.gz (timeout 10 seconds)
movit.x86_64: I: checking
movit.x86_64: I: checking-url https://movit.sesse.net (timeout 10 seconds)
movit.x86_64: W: shared-lib-calls-exit /usr/lib64/libmovit.so.7.0.1 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

movit-devel.x86_64: I: checking
movit-devel.x86_64: I: checking-url https://movit.sesse.net (timeout 10 seconds)
movit-devel.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

movit-data.noarch: I: checking
movit-data.noarch: I: checking-url https://movit.sesse.net (timeout 10 seconds)
movit-debuginfo.x86_64: I: checking
movit-debuginfo.x86_64: I: checking-url https://movit.sesse.net (timeout 10 seconds)
5 packages and 1 specfiles checked; 0 errors, 2 warnings.

Comment 1 srakitnican 2017-09-15 20:17:15 UTC
There are a couple of issues that needs to be addressed before the package is approved.

- You are including COPYING file from outside the sources. Please don't do
  that and instead contact upstream about this issue. Fedora Packaging
  Guidelines are clear about this: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Text
- License tag seems to not match actual project license, movit appears to be
  GPLv2+
- Rpmlint warning 'shared-lib-calls-exit' seems a pretty serious one, I am not
  confident it is harmless. We would need a revaluation from either the author
  or an expert. Not sure if this blocks the package submission either.
$ grep -R 'exit(' .
./demo.cpp:		exit(1);
./demo.cpp:		exit(1);
./demo.cpp:		exit(1);
./util.cpp:		exit(1);
./util.cpp:		exit(1);
./util.cpp:		exit(1);
./util.cpp:		exit(1);
./util.cpp:		exit(1);
./util.cpp:		exit(1);
./effect_chain.cpp:		exit(1);
./config.guess:				exit(1);
./config.guess:			exit(0);
./resource_pool.cpp:				exit(1);
./resource_pool.cpp:		exit(1);
./gtest_sdl_main.cpp:		exit(1);
./gtest_sdl_main.cpp:	exit(err);
- There is a test included in Makefile, although it would be nice to include it
  in %check section, it is not mandatory.

Bellow is fedora-review report.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 102400 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in movit-
     data , movit-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
     srakitnican: Makefile seems to support 'make check'
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: movit-1.5.3-1.fc28.x86_64.rpm
          movit-devel-1.5.3-1.fc28.x86_64.rpm
          movit-data-1.5.3-1.fc28.noarch.rpm
          movit-debuginfo-1.5.3-1.fc28.x86_64.rpm
          movit-1.5.3-1.fc28.src.rpm
movit.x86_64: W: shared-lib-calls-exit /usr/lib64/libmovit.so.7.0.1 exit@GLIBC_2.2.5
movit.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
movit.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
movit-devel.x86_64: W: only-non-binary-in-usr-lib
movit-debuginfo.x86_64: E: debuginfo-without-sources
5 packages and 0 specfiles checked; 1 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: movit-debuginfo-1.5.3-1.fc28.x86_64.rpm
movit-debuginfo.x86_64: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
movit (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libepoxy.so.0()(64bit)
    libfftw3.so.3()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.8)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

movit-data (rpmlib, GLIBC filtered):

movit-debuginfo (rpmlib, GLIBC filtered):

movit-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmovit.so.7()(64bit)
    movit(x86-64)
    pkgconfig(eigen3)
    pkgconfig(epoxy)
    pkgconfig(fftw3)



Provides
--------
movit:
    libmovit.so.7()(64bit)
    movit
    movit(x86-64)

movit-data:
    movit-data

movit-debuginfo:
    debuginfo(build-id)
    movit-debuginfo
    movit-debuginfo(x86-64)

movit-devel:
    movit-devel
    movit-devel(x86-64)
    pkgconfig(movit)



Source checksums
----------------
https://movit.sesse.net/movit-1.5.3.tar.gz :
  CHECKSUM(SHA256) this package     : ead191d717dbefbe914260ed0335cf04a7dfc6fde8f23293c5ca7f88e45ace81
  CHECKSUM(SHA256) upstream package : ead191d717dbefbe914260ed0335cf04a7dfc6fde8f23293c5ca7f88e45ace81


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1492084 -o-r fedora-rawhide-x86_64
Buildroot used: fedora-25-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 srakitnican 2017-09-15 20:52:38 UTC
From fedora-devel IRC about shared-lib-calls-exit:
[22:38] <ignatenkobrain> srakitnican: no, it's not blocker

Comment 3 MartinKG 2017-09-16 17:00:03 UTC
(In reply to srakitnican from comment #1)
> There are a couple of issues that needs to be addressed before the package
> is approved.
> 
> - You are including COPYING file from outside the sources. Please don't do
>   that and instead contact upstream about this issue. Fedora Packaging
>   Guidelines are clear about this:
> https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/
> LicensingGuidelines#License_Text

file COPYING is now in the git:
https://git.sesse.net/?p=movit;a=blob_plain;f=COPYING;hb=13f6483a23b8d34947a0967269ba6ee19d106562

hwo should i comment this in the spec file ?

> - License tag seems to not match actual project license, movit appears to be
>   GPLv2+

will change to GPLv2+

> - Rpmlint warning 'shared-lib-calls-exit' seems a pretty serious one, I am
> not
>   confident it is harmless. We would need a revaluation from either the
> author
>   or an expert. Not sure if this blocks the package submission either.
> $ grep -R 'exit(' .
> ./demo.cpp:		exit(1);
> ./demo.cpp:		exit(1);
> ./demo.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./util.cpp:		exit(1);
> ./effect_chain.cpp:		exit(1);
> ./config.guess:				exit(1);
> ./config.guess:			exit(0);
> ./resource_pool.cpp:				exit(1);
> ./resource_pool.cpp:		exit(1);
> ./gtest_sdl_main.cpp:		exit(1);
> ./gtest_sdl_main.cpp:	exit(err);

(In reply to srakitnican from comment #2)
> From fedora-devel IRC about shared-lib-calls-exit:
> [22:38] <ignatenkobrain> srakitnican: no, it's not blocker

ok noticed.

> - There is a test included in Makefile, although it would be nice to include
> it
>   in %check section, it is not mandatory.

make check fails due src/gtest-all.cc is missing, if I'm right.

+ export GTEST_DIR=/usr/include/gtest
+ GTEST_DIR=/usr/include/gtest
+ make check
g++ -MMD -MP  -Wall -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fvisibility-inlines-hidden -I/usr/include/gtest/include  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT  -I/usr/include/eigen3    -o effect_chain_test.o -c effect_chain_test.cpp
make: *** No rule to make target '/usr/include/gtest/src/gtest-all.cc', needed by 'gtest-all.o'.  Stop.
error: Bad exit status from /var/tmp/rpm-tmp.r8UCxK (%check)

Comment 4 srakitnican 2017-09-23 11:45:06 UTC
(In reply to mgansser@alice.de from comment #3)
> (In reply to srakitnican from comment #1)
> 
> file COPYING is now in the git:
> https://git.sesse.net/?p=movit;a=blob_plain;f=COPYING;
> hb=13f6483a23b8d34947a0967269ba6ee19d106562
> 
> hwo should i comment this in the spec file ?

I guess it is fine in that case then, but please add your COPYING text file to %license instead to main and data packages, adding it to devel package is unnecessary since it depends on the main package. Leaving a comment 
explaining why you are adding the license test file.

While we are at it, you don't have any dependencies on the data package or vice versa. Does the main package work without it?

> make check fails due src/gtest-all.cc is missing, if I'm right.
> 
> + export GTEST_DIR=/usr/include/gtest
> + GTEST_DIR=/usr/include/gtest
> + make check
> g++ -MMD -MP  -Wall -O2 -g -pipe -Wall -Werror=format-security
> -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong
> --param=ssp-buffer-size=4 -grecord-gcc-switches
> -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic
> -fvisibility-inlines-hidden -I/usr/include/gtest/include  -I/usr/include/SDL
> -D_GNU_SOURCE=1 -D_REENTRANT  -I/usr/include/eigen3    -o
> effect_chain_test.o -c effect_chain_test.cpp
> make: *** No rule to make target '/usr/include/gtest/src/gtest-all.cc',
> needed by 'gtest-all.o'.  Stop.
> error: Bad exit status from /var/tmp/rpm-tmp.r8UCxK (%check)

Yeah it seems broken, it is alright to leave it out.

Comment 5 MartinKG 2017-09-23 14:15:33 UTC
(In reply to srakitnican from comment #4)
> (In reply to mgansser@alice.de from comment #3)
> > (In reply to srakitnican from comment #1)
> > 
> > file COPYING is now in the git:
> > https://git.sesse.net/?p=movit;a=blob_plain;f=COPYING;
> > hb=13f6483a23b8d34947a0967269ba6ee19d106562
> > 
> > hwo should i comment this in the spec file ?
> 
> I guess it is fine in that case then, but please add your COPYING text file
> to %license instead to main and data packages, adding it to devel package is
> unnecessary since it depends on the main package. Leaving a comment 
> explaining why you are adding the license test file.

add %license macro
add comment 
> While we are at it, you don't have any dependencies on the data package or
> vice versa. Does the main package work without it?
> 
> > make check fails due src/gtest-all.cc is missing, if I'm right.
> > 
> > + export GTEST_DIR=/usr/include/gtest
> > + GTEST_DIR=/usr/include/gtest
> > + make check
> > g++ -MMD -MP  -Wall -O2 -g -pipe -Wall -Werror=format-security
> > -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong
> > --param=ssp-buffer-size=4 -grecord-gcc-switches
> > -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic
> > -fvisibility-inlines-hidden -I/usr/include/gtest/include  -I/usr/include/SDL
> > -D_GNU_SOURCE=1 -D_REENTRANT  -I/usr/include/eigen3    -o
> > effect_chain_test.o -c effect_chain_test.cpp
> > make: *** No rule to make target '/usr/include/gtest/src/gtest-all.cc',
> > needed by 'gtest-all.o'.  Stop.
> > error: Bad exit status from /var/tmp/rpm-tmp.r8UCxK (%check)
> 
> Yeah it seems broken, it is alright to leave it out.

skipped test build


Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/movit.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/movit-1.5.3-2.fc26.src.rpm

%changelog
* Sat Sep 23 2017 Martin Gansser <martinkg@fedoraproject.org> - 1.5.3-2
- Add comment why adding licensing test file
- Add %%license macro only to main package
- Add RR %%{name}-data = %%{version}-%%{release} to main package
- Add RR %%{name} = %%{version}-%%{release} to data sub package

Comment 6 srakitnican 2017-09-23 16:17:23 UTC
This look good now, package approved.

Comment 7 MartinKG 2017-09-23 16:25:30 UTC
Thanks for reviewing this package.

Comment 8 Gwyn Ciesla 2017-09-23 20:19:10 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/movit

Comment 9 MartinKG 2017-09-24 07:58:13 UTC
package has been built successfully on f25, f26, f27 and rawhide.

Comment 10 srakitnican 2017-09-24 09:39:01 UTC
Hi Terje,

This package fails to build test cases if I am understanding correctly due to missing sources from gtest (comment #3). Do you know what is the problem here? Should the sources be included in gtest package, with the project itself or something else?

Comment 11 MartinKG 2017-09-24 11:48:47 UTC
(In reply to srakitnican from comment #10)
> Hi Terje,
> 
> This package fails to build test cases if I am understanding correctly due
> to missing sources from gtest (comment #3). Do you know what is the problem
> here? Should the sources be included in gtest package, with the project
> itself or something else?

this was the answer i already got from the developer:

On Sat, Sep 16, 2017 at 03:50:03PM +0200, Martin Gansser wrote:
> make: *** No rule to make target '/usr/src/gtest/src/gtest-all.cc', needed
> by 'gtest-all.o'.  Stop.
>
> how can i solve this ?

You need to install Google Test and set GTEST_DIR. (Google Test upstream does
not recommend shipping prebuilt binaries.)

Comment 12 Terje Røsten 2017-10-23 17:04:48 UTC
FYI: gtest 1.8.0 is available in rawhide now. Sources included in package.

Can you try tip about setting GTEST_DIR?

Comment 13 MartinKG 2017-10-24 10:56:50 UTC
(In reply to Terje Røsten from comment #12)
> FYI: gtest 1.8.0 is available in rawhide now. Sources included in package.
> 
> Can you try tip about setting GTEST_DIR?

there is no gtest-all.cc in the package gtest-devel:

+ export GTEST_DIR=/usr/include/gtest
+ GTEST_DIR=/usr/include/gtest
+ make check
g++ -MMD -MP  -Wall -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fvisibility-inlines-hidden -I/usr/include/gtest/include -I/usr/include/SDL2 -D_REENTRANT   -I/usr/include/eigen3    -DHAVE_SDL2 -o effect_chain_test.o -c effect_chain_test.cpp
make: *** No rule to make target '/usr/include/gtest/src/gtest-all.cc', needed by 'gtest-all.o'.  Stop.
error: Bad exit status from /var/tmp/rpm-tmp.LBk107 (%install)


Note You need to log in before you can comment on or make changes to this bug.